"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formatCssLoader = exports.cssModuleNaming = void 0;

var cssModuleNaming = function cssModuleNaming(prod) {
  var hashing = 'hash:base64';
  return prod ? "[".concat(hashing, ":7]") : "[name]--[local]__[".concat(hashing, ":5]");
};

exports.cssModuleNaming = cssModuleNaming;

var formatCssLoader = function formatCssLoader(isProduction) {
  var cssOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  var postOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  var cssLoaders = [{
    loader: 'css',
    options: cssOptions || {
      modules: true,
      localIdentName: cssModuleNaming(isProduction),
      sourceMap: !isProduction //minimize      : isProductionEnvironment
      //importLoaders: 1

    }
  }];
  var postCssLoaders = {
    loader: 'postcss',
    options: {
      ident: 'postcss',
      plugins: function plugins() {
        return [require('autoprefixer')(postOptions || {
          browsers: ['>2%', 'last 4 versions', 'Firefox ESR', 'not ie < 9']
        })];
      }
    }
  };
  return isProduction ? [].concat(cssLoaders, postCssLoaders) : cssLoaders;
};

exports.formatCssLoader = formatCssLoader;